%define anolis_release 19

%global commit 4c79120bcdbde0616f592458ccde7035e92ca3d8
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:           execstack
Summary:        Utility to set/clear/query executable stack bit
Version:        0.5.0
Release:        %{anolis_release}%{?dist}
License: 	GPLv2+
Source0: 	https://github.com/keszybz/prelink/archive/%{commit}.tar.gz
Patch0001:  	0001-Add-PL_ARCH-for-AArch64.patch
Patch0002: 	0002-execstack-configure-c99.patch
Patch0003:	0003-Add-PL_ARCH-for-Loongarch64.patch
Patch0004:      0004-Add-PL_ARCH-for-Riscv64.patch

BuildRequires: gcc gcc-c++ make
BuildRequires: elfutils-libelf-devel libselinux-devel, libselinux-utils
Requires: glibc >= 2.2.4-18, coreutils, findutils
Requires: util-linux, gawk, grep
Obsoletes:     prelink < 0.5.0-8

%description
Execstack is a Linux command that allows the execution of code on the stack.
By default, modern operating systems prevent code from being executed on the
stack as a security measure against buffer overflow attacks. However, in some
cases, it may be necessary to execute code on the stack, for example, when
running legacy applications or when working with certain programming languages.
The execstack command can be used to mark a particular binary executable as
"executable on the stack" or to check if an existing executable has this property.

%package doc
Summary:	Documents for %{name}
Requires:	%{name} = %{EVR}
BuildArch:	noarch

%description doc
This document package contains the doc files for %{name}.

%prep
%autosetup -p1 -n prelink-%{commit}

%build
sed -i -e '/^prelink_LDADD/s/$/ -lpthread/' src/Makefile.{am,in}
%configure
%{make_build} -C gelf
%{make_build} -C gelfx
%{make_build} -C gelfx32
%{make_build} -C src execstack

%check
cp src/execstack test
src/execstack -q test | grep '^-'
src/execstack -s test
src/execstack -q test | grep '^X'
src/execstack -c test
src/execstack -q test | grep '^-'

%install
install -D src/execstack %{buildroot}%{_bindir}/execstack
install -D -m 0644 doc/execstack.8 %{buildroot}%{_mandir}/man8/execstack.8

%files
%license COPYING
%{_bindir}/execstack
%{_mandir}/man8/execstack.8.*

%files doc
%doc ChangeLog NEWS README TODO THANKS

%changelog
* Mon Jun 03 2025 NewStart <os@gd-linux.com> - 0.5.0-19
- add riscv64 support

* Wed Dec 27 2023 happy_orange <songnannan@linux.alibaba.com> - 0.5.0-18
- fix the source error

* Mon Oct  9 2023 Wenlong Zhang<zhangwenlong@loongson.cn> - 0.5.0-17
- add loongarch64 support for execstack

* Sat Apr 15 2023 Funda Wang <fundawang@yeah.net> - 0.5.0-16
- Bump release for upgrading from anolis 8

* Sat Apr 15 2023 Heng Qi <hengqi@linux.alibaba.com> - 0.5.0-1
- Init the package
